Index: /trunk/examples/objects/app-fermi/fermi1.cc
===================================================================
--- /trunk/examples/objects/app-fermi/fermi1.cc	(revision 1559)
+++ /trunk/examples/objects/app-fermi/fermi1.cc	(revision 1560)
@@ -74,15 +74,12 @@
 
     // do it the easy way,
-    // create a plot to add to the library
+    // create a plot and add to the library
     // p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
 
-    Rappture::Plot *p1 = new Rappture::Plot();
+    Rappture::Plot *p1 = new Rappture::Plot(lib);
     p1->add(nPts,fArr,EArr,"",curveLabel,curveDesc);
     p1.propstr("xlabel","Fermi-Dirac Factor");
     p1.propstr("ylabel","Energy");
     p1.propstr("yunits","eV");
-
-    // add the plot to the library
-    lib.put(p1);
 
 
@@ -91,5 +88,5 @@
     // c1->axis("xaxis","xlabel","xdesc","units","scale",dataArr,nPts);
 
-    Rappture::Curve *c1 = new Rappture::Curve("output.curve(FDF)");
+    Rappture::Curve *c1 = new Rappture::Curve(lib,"FDF");
     c1->label(curveLabel);
     c1->desc(curveDesc);
Index: /trunk/examples/objects/app-fermi/fermi2.cc
===================================================================
--- /trunk/examples/objects/app-fermi/fermi2.cc	(revision 1559)
+++ /trunk/examples/objects/app-fermi/fermi2.cc	(revision 1560)
@@ -25,10 +25,11 @@
     Rappture::Number *T  = NULL;
     Rappture::Number *Ef = NULL;
-    double E            = 0.0;
     double dE           = 0.0;
     double kT           = 0.0;
     double Emin         = 0.0;
     double Emax         = 0.0;
-    double f            = 0.0;
+    size_t nPts         = 200;
+    double E[nPts];
+    double f[nPts];
 
     // create a rappture library from the file filePath
@@ -55,18 +56,14 @@
     Emax = Ef->value("eV") + 10*kT;
 
-    dE = 0.005*(Emax-Emin);
+    dE = (1.0/nPts)*(Emax-Emin);
 
-    Rappture::SimpleDoubleBuffer fBuf;
-    Rappture::SimpleDoubleBuffer EBuf;
-
-    for (E = Emin; E < Emax; E = E + dE) {
+    E = Emin;
+    for (size_t idx = 0; idx < nPts; idx++) {
+        E = E + dE;
         f = 1.0/(1.0 + exp((E - Ef)/kT));
-        fBuf.append(f);
-        EBuf.append(E);
+        fArr[idx] = f;
+        EArr[idx] = E;
         rpUtilsProgress((int)((E-Emin)/(Emax-Emin)*100),"Iterating");
     }
-    const double *fArr = fBuf.data();
-    const double *EArr = EBuf.data();
-    size_t nPts = fBuf.nmemb();
 
     const char *curveLabel = "Fermi-Dirac Curve"
@@ -75,7 +72,8 @@
     // do it the easy way,
     // create a plot to add to the library
+    // plot is registered with lib upon object creation
     // p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
 
-    Rappture::Plot *p1 = new Rappture::Plot();
+    Rappture::Plot *p1 = new Rappture::Plot(lib);
     p1->add(nPts,fArr,EArr,"",curveLabel,curveDesc);
     p1.propstr("xlabel","Fermi-Dirac Factor");
@@ -83,27 +81,11 @@
     p1.propstr("yunits","eV");
 
-    // add the plot to the library
-    lib.put(p1);
-
-
-    // or do it the harder way,
-    // create a curve to add to the library
-    // c1->axis("xaxis","xlabel","xdesc","units","scale",dataArr,nPts);
-
-    Rappture::Curve *c1 = new Rappture::Curve("output.curve(FDF)");
-    c1->label(curveLabel);
-    c1->desc(curveDesc);
-    c1->axis("xaxis","Fermi-Dirac Factor","","","",fArr,nPts);
-    c1->axis("yaxis","Energy","","eV","",EArr,nPts);
-
-    // add the curve to the library
-    lib.put(c1);
-
     lib.result();
 
     // clean up memory
     delete lib;
+    delete T;
+    delete Ef;
     delete p1;
-    delete c1;
 
     return 0;
Index: /trunk/examples/objects/app-fermi/fermi3.cc
===================================================================
--- /trunk/examples/objects/app-fermi/fermi3.cc	(revision 1560)
+++ /trunk/examples/objects/app-fermi/fermi3.cc	(revision 1560)
@@ -0,0 +1,86 @@
+// ----------------------------------------------------------------------
+//  EXAMPLE: Fermi-Dirac function in C++.
+//
+//  This simple example shows how to use Rappture within a simulator
+//  written in C++.
+// ======================================================================
+//  AUTHOR:  Derrick Kearney, Purdue University
+//  Copyright (c) 2005-2009  Purdue Research Foundation
+//
+//  See the file "license.terms" for information on usage and
+//  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+// ======================================================================
+
+#include "rappture.h"
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <math.h>
+#include <unistd.h>
+
+int main(int argc, char * argv[]) {
+
+    Rappture::Library lib;
+
+    Rappture::Number T;
+    Rappture::Number Ef;
+    double dE           = 0.0;
+    double kT           = 0.0;
+    double Emin         = 0.0;
+    double Emax         = 0.0;
+    size_t nPts         = 200;
+    double E[nPts];
+    double f[nPts];
+
+    // create a rappture library from the file filePath
+    lib = Rappture::Library(argv[1]);
+
+    if (lib.error() != 0) {
+        // cannot open file or out of memory
+        fprintf(stderr, lib.traceback());
+        exit(lib.error());
+    }
+
+    Rappture::connect(lib,"temperature",&T);
+    Rappture::connect(lib,"Ef",&Ef);
+
+    if (lib.error() != 0) {
+        // there were errors while retrieving input data values
+        // dump the tracepack
+        fprintf(stderr, lib.traceback());
+        exit(lib.error());
+    }
+
+    kT = 8.61734e-5 * T->value("K");
+    Emin = Ef->value("eV") - 10*kT;
+    Emax = Ef->value("eV") + 10*kT;
+
+    dE = (1.0/nPts)*(Emax-Emin);
+
+    E = Emin;
+    for (size_t idx = 0; idx < nPts; idx++) {
+        E = E + dE;
+        f = 1.0/(1.0 + exp((E - Ef)/kT));
+        fArr[idx] = f;
+        EArr[idx] = E;
+        rpUtilsProgress((int)((E-Emin)/(Emax-Emin)*100),"Iterating");
+    }
+
+    const char *curveLabel = "Fermi-Dirac Curve"
+    const char *curveDesc = "Plot of Fermi-Dirac Calculation";
+
+    // do it the easy way,
+    // create a plot to add to the library
+    // plot is registered with lib upon object creation
+    // p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
+
+    Rappture::Plot p1(lib);
+    p1.add(nPts,fArr,EArr,"",curveLabel,curveDesc);
+    p1.propstr("xlabel","Fermi-Dirac Factor");
+    p1.propstr("ylabel","Energy");
+    p1.propstr("yunits","eV");
+
+    lib.result();
+
+    return 0;
+}
Index: /trunk/examples/objects/curve/curve.cc
===================================================================
--- /trunk/examples/objects/curve/curve.cc	(revision 1559)
+++ /trunk/examples/objects/curve/curve.cc	(revision 1560)
@@ -1,4 +1,7 @@
 #include <iostream>
 #include "RpCurve.h"
+
+size_t indent = 0;
+size_t tabstop = 4;
 
 int test(
@@ -34,5 +37,5 @@
     }
 
-    std::cout << "xml: " << n->xml() << std::endl;
+    std::cout << "xml: " << n->xml(indent,tabstop) << std::endl;
     return 0;
 }
Index: /trunk/examples/objects/histogram/histogram.cc
===================================================================
--- /trunk/examples/objects/histogram/histogram.cc	(revision 1559)
+++ /trunk/examples/objects/histogram/histogram.cc	(revision 1560)
@@ -36,8 +36,10 @@
     h3->yaxis("ylabel3","ydesc3","yunits3");
 
+    size_t indent = 0;
+    size_t tabstop = 4;
 
-    std::printf("xml: %s\n",h1->xml());
-    std::printf("xml: %s\n",h2->xml());
-    std::printf("xml: %s\n",h3->xml());
+    std::printf("xml: %s\n",h1->xml(indent,tabstop));
+    std::printf("xml: %s\n",h2->xml(indent,tabstop));
+    std::printf("xml: %s\n",h3->xml(indent,tabstop));
 
     return 0;
Index: /trunk/examples/objects/number/number.cc
===================================================================
--- /trunk/examples/objects/number/number.cc	(revision 1559)
+++ /trunk/examples/objects/number/number.cc	(revision 1560)
@@ -1,8 +1,15 @@
 #include <iostream>
+#include <errno.h>
+#include <fstream>
+#include <sys/stat.h>
 #include "RpNumber.h"
+
+size_t indent = 0;
+size_t tabstop = 4;
 
 int
 printNumber(Rappture::Number *n)
 {
+    std::cout << "name: " << n->name() << std::endl;
     std::cout << "path: " << n->path() << std::endl;
     std::cout << "label: " << n->label() << std::endl;
@@ -13,22 +20,201 @@
     std::cout << "max: " << n->max() << std::endl;
     std::cout << "units: " << n->units() << std::endl;
-    std::cout << "xml: " << n->xml() << std::endl;
-    return 0;
+    std::cout << "xml:\n" << n->xml(indent,tabstop) << std::endl;
+    return 0;
+}
+
+int testStringVal(
+    const char *testname,
+    const char *desc,
+    const char *expected,
+    const char *received)
+{
+    if ((!expected && received) ||
+        (expected && !received) ||
+        (expected && received && strcmp(expected,received) != 0)) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%s\"\n",expected);
+        printf("\treceived \"%s\"\n",received);
+        return 1;
+    }
+    return 0;
+}
+
+int testDoubleVal(
+    const char *testname,
+    const char *desc,
+    double expected,
+    double received)
+{
+    if (expected != received) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%g\"\n",expected);
+        printf("\treceived \"%g\"\n",received);
+        return 1;
+    }
+    return 0;
+}
+
+size_t
+readFile (
+    const char *filePath,
+    const char **buf)
+{
+    if (buf == NULL) {
+        fprintf(stderr,"buf is NULL while opening file \"%s\"", filePath);
+        return 0;
+    }
+
+    FILE *f;
+    f = fopen(filePath, "rb");
+    if (f == NULL) {
+        fprintf(stderr,"can't open \"%s\": %s", filePath, strerror(errno));
+        return 0;
+    }
+    struct stat stat;
+    if (fstat(fileno(f), &stat) < 0) {
+        fprintf(stderr,"can't stat \"%s\": %s", filePath, strerror(errno));
+        return 0;
+    }
+    off_t size;
+    size = stat.st_size;
+    char* memblock;
+    memblock = new char [size+1];
+    if (memblock == NULL) {
+        fprintf(stderr,"can't allocate %zu bytes for file \"%s\": %s",
+            size, filePath, strerror(errno));
+        fclose(f);
+        return 0;
+    }
+
+    size_t nRead;
+    nRead = fread(memblock, sizeof(char), size, f);
+    fclose(f);
+
+    if (nRead != (size_t)size) {
+        fprintf(stderr,"can't read %zu bytes from \"%s\": %s", size, filePath,
+            strerror(errno));
+        return 0;
+    }
+
+    memblock[size] = '\0';
+    *buf = memblock;
+    return nRead;
+}
+int number_0_0 ()
+{
+    const char *testdesc = "test number full constructor";
+    const char *testname = "number_0_0";
+    int retVal = 0;
+
+    const char *name = "temp";
+    const char *units = "K";
+    double def = 300;
+    double min = 0;
+    double max = 1000;
+    const char *label = "mylabel";
+    const char *desc = "mydesc";
+
+    Rappture::Number *n = NULL;
+
+    n = new Rappture::Number(name,units,def,min,max,label,desc);
+
+    if (n == NULL) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", testdesc);
+        printf("\terror creating number object\n");
+        retVal = 1;
+    }
+
+    retVal |= testStringVal(testname,testdesc,name,n->name());
+    retVal |= testStringVal(testname,testdesc,units,n->units());
+    retVal |= testDoubleVal(testname,testdesc,def,n->def());
+    retVal |= testDoubleVal(testname,testdesc,min,n->min());
+    retVal |= testDoubleVal(testname,testdesc,max,n->max());
+    retVal |= testStringVal(testname,testdesc,label,n->label());
+    retVal |= testStringVal(testname,testdesc,desc,n->desc());
+
+    if (n != NULL) {
+        delete n;
+    }
+
+    return retVal;
+}
+
+int number_0_1 ()
+{
+    const char *testdesc = "test number constuctor";
+    const char *testname = "number_0_0";
+    int retVal = 0;
+
+    const char *name = "eV";
+    const char *units = "eV";
+    double def = 1.4;
+
+    Rappture::Number *n = NULL;
+
+    n = new Rappture::Number(name,units,def);
+
+    if (n == NULL) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", testdesc);
+        printf("\terror creating number object\n");
+        retVal = 1;
+    }
+
+    retVal |= testStringVal(testname,testdesc,name,n->name());
+    retVal |= testStringVal(testname,testdesc,units,n->units());
+    retVal |= testDoubleVal(testname,testdesc,def,n->def());
+
+    if (n != NULL) {
+        delete n;
+    }
+
+    return retVal;
+}
+
+int number_1_0 ()
+{
+    const char *testdesc = "test constructing number from xml";
+    const char *testname = "number_1_0";
+    const char *filePath = "number_1_0_in.xml";
+    int retVal = 0;
+
+    const char *buf = NULL;
+    readFile(filePath,&buf);
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.xml(buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
 }
 
 int main()
 {
-    Rappture::Number *n = NULL;
-
-    n = new Rappture::Number("input.number(temperature)","K",300,
-                             0,1000,"mylabel","mydesc");
-
-    printNumber(n);
-
-    Rappture::Number n1("input.number(eV)","eV",1.4);
-    printNumber(&n1);
-
-    delete n;
-
-    return 0;
-}
+    number_0_0();
+    number_0_1();
+    number_1_0();
+
+    return 0;
+}
Index: /trunk/examples/objects/path/path.cc
===================================================================
--- /trunk/examples/objects/path/path.cc	(revision 1559)
+++ /trunk/examples/objects/path/path.cc	(revision 1560)
@@ -8,5 +8,7 @@
     const char *received)
 {
-    if (strcmp(expected,received) != 0) {
+    if ((!expected && received) ||
+        (expected && !received) ||
+        (expected && received && strcmp(expected,received) != 0)) {
         printf("Error: %s\n", testname);
         printf("\t%s\n", desc);
@@ -114,5 +116,5 @@
 
     const char *path = "input.group(tabs).number(mynum).current";
-    const char *expected = "";
+    const char *expected = NULL;
     const char *received = NULL;
 
@@ -773,4 +775,11 @@
 // FIXME: add test for parent get/set functions
 // FIXME: add test for path get/set functions
+// FIXME: add test for changing the curr location
+//        using first,last,next,prev and checking
+//        comp, type, parent,id fxns
+// FIXME: add test for numbered paths
+//        input.number2
+//        input.number2(eee)
+//        input.number(eee)2
 
 int main()
Index: /trunk/examples/objects/plot/plot.cc
===================================================================
--- /trunk/examples/objects/plot/plot.cc	(revision 1559)
+++ /trunk/examples/objects/plot/plot.cc	(revision 1560)
@@ -41,5 +41,8 @@
     std::printf("curveCnt = %zu\n",curveCnt);
 
-    std::printf("xml: %s\n",p1->xml());
+    size_t indent = 0;
+    size_t tabstop = 4;
+
+    std::printf("xml: %s\n",p1->xml(indent,tabstop));
 
 /*
Index: /trunk/examples/objects/scatter/scatter.cc
===================================================================
--- /trunk/examples/objects/scatter/scatter.cc	(revision 1559)
+++ /trunk/examples/objects/scatter/scatter.cc	(revision 1560)
@@ -41,5 +41,7 @@
     std::printf("curveCnt = %zu\n",curveCnt);
 
-    std::printf("xml: %s\n",p1->xml());
+    size_t indent = 0;
+    size_t tabstop = 4;
+    std::printf("xml: %s\n",p1->xml(indent,tabstop));
 
 /*
Index: /trunk/examples/objects/tree/tree.c
===================================================================
--- /trunk/examples/objects/tree/tree.c	(revision 1559)
+++ /trunk/examples/objects/tree/tree.c	(revision 1560)
@@ -14,5 +14,5 @@
     Rp_Tree t;
 
-    Rp_TreeCreate(treeName,t);
+    Rp_TreeCreate(treeName,&t);
     received = Rp_TreeName(t);
 
@@ -28,8 +28,183 @@
 }
 
+int tree_1_0 ()
+{
+    const char *desc = "test creation of tree node";
+    const char *testname = "tree_1_0";
+
+    const char *treeName = "mytree";
+    const char *nodeName = "mynode";
+    const char *expected = "mynode";
+    const char *received = NULL;
+
+    Rp_Tree t;
+    Rp_TreeNode n = NULL;
+
+    Rp_TreeCreate(treeName,&t);
+    n = Rp_TreeCreateNode(t, Rp_TreeRootNode(t), nodeName, 0);
+    received = Rp_TreeNodeLabel(n);
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%s\"\n",expected);
+        printf("\treceived \"%s\"\n",received);
+        return 1;
+    }
+
+    return 0;
+}
+
+int tree_2_0 ()
+{
+    const char *desc = "test creation of tree node with single child";
+    const char *testname = "tree_2_0";
+
+    const char *treeName = "mytree";
+    const char *parentNodeName = "myparentnode";
+    const char *childNodeName = "mychildnode";
+    const char *expected = "mychildnode";
+    const char *received = NULL;
+
+    Rp_Tree t;
+    Rp_TreeNode parent = NULL;
+    Rp_TreeNode child = NULL;
+
+    Rp_TreeCreate(treeName,&t);
+    parent = Rp_TreeCreateNode(t, Rp_TreeRootNode(t), parentNodeName, 0);
+    child = Rp_TreeCreateNode(t, parent, childNodeName, 0);
+    received = Rp_TreeNodeLabel(child);
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%s\"\n",expected);
+        printf("\treceived \"%s\"\n",received);
+        return 1;
+    }
+
+    return 0;
+}
+
+int tree_2_1 ()
+{
+    const char *desc = "test creation of tree node with multiple children";
+    const char *testname = "tree_2_1";
+
+    const char *treeName = "mytree";
+    const char *parentNodeName = "myparentnode";
+    size_t expected = 5;
+    size_t received = 0;
+
+    Rp_Tree t;
+    Rp_TreeNode parent = NULL;
+
+    Rp_TreeCreate(treeName,&t);
+    parent = Rp_TreeCreateNode(t, Rp_TreeRootNode(t), parentNodeName, 0);
+
+    Rp_TreeCreateNode(t, parent, "child1", 0);
+    Rp_TreeCreateNode(t, parent, "child2", 0);
+    Rp_TreeCreateNode(t, parent, "child3", 0);
+    Rp_TreeCreateNode(t, parent, "child4", 0);
+    Rp_TreeCreateNode(t, parent, "child5", 0);
+
+    received = Rp_TreeNodeDegree(parent);
+
+    if (expected != received) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%zu\"\n",expected);
+        printf("\treceived \"%zu\"\n",received);
+        return 1;
+    }
+
+    return 0;
+}
+
+int tree_2_2 ()
+{
+    const char *desc = "test search for child node";
+    const char *testname = "tree_2_2";
+
+    const char *treeName = "mytree";
+    const char *parentNodeName = "myparentnode";
+    const char *childNodeName = "mychildnode";
+    const char *expected = "mychildnode";
+    const char *received = NULL;
+
+    Rp_Tree t;
+    Rp_TreeNode parent = NULL;
+    Rp_TreeNode foundChild = NULL;
+
+    Rp_TreeCreate(treeName,&t);
+    parent = Rp_TreeCreateNode(t, Rp_TreeRootNode(t), parentNodeName, 0);
+
+    Rp_TreeCreateNode(t, parent, "child1", 0);
+    Rp_TreeCreateNode(t, parent, "child2", 0);
+    Rp_TreeCreateNode(t, parent, "child3", 0);
+    Rp_TreeCreateNode(t, parent, childNodeName, 0);
+    Rp_TreeCreateNode(t, parent, "child4", 0);
+    Rp_TreeCreateNode(t, parent, "child5", 0);
+
+    foundChild = Rp_TreeFindChild(parent,childNodeName);
+    received = Rp_TreeNodeLabel(foundChild);
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%s\"\n",expected);
+        printf("\treceived \"%s\"\n",received);
+        return 1;
+    }
+
+    return 0;
+}
+
+int tree_3_0 ()
+{
+    const char *desc = "test adding node with string value";
+    const char *testname = "tree_3_0";
+
+    const char *treeName = "mytree";
+    const char *parentNodeName = "myparentnode";
+    const char *childNodeName = "mychildnode";
+    const char *childNodeValue = "quick brown fox";
+    const char *expected = "quick brown fox1";
+    const char *received = NULL;
+
+    Rp_Tree t;
+    Rp_TreeNode parent = NULL;
+    Rp_TreeNode child = NULL;
+
+    Rp_TreeCreate(treeName,&t);
+    parent = Rp_TreeCreateNode(t, Rp_TreeRootNode(t), parentNodeName, 0);
+
+    child = Rp_TreeCreateNode(t, parent, childNodeName, 0);
+    Rp_TreeSetValue(t,child,"value",(void *)childNodeValue);
+
+    Rp_TreeGetValue(t,child,"value",(void **)&received);
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected \"%s\"\n",expected);
+        printf("\treceived \"%s\"\n",received);
+        return 1;
+    }
+
+    return 0;
+}
+
 int main()
 {
     tree_0_0();
-
-    return 0;
-}
+    tree_1_0();
+    tree_2_0();
+    tree_2_1();
+    tree_2_2();
+    tree_3_0();
+
+    // add test case where two children have the same name but different ids
+
+    return 0;
+}
